AnimatedSprite = class(SpriteStrip)

function AnimatedSprite:__init(texture, fw, fh, fps, nf, x, y, w, h, cx, cy)
   SpriteStrip.__init(self, texture, fw, fh, x, y, w, h, cx, cy)
   self.nf = nf or (self.nfw * self.nfh)  -- total # frames
   self.fps = fps or self.nf              -- frames/sec
   self.timer = pge.timer.create()
   self.loop = true
end

function AnimatedSprite:reset()
   self.timer:update()
end

function AnimatedSprite:draw(x, y, sx, sy, r, a)
   local frame = self.fps * self.timer:peekdelta()

   if self.loop then
      frame = wrap(frame, 0, self.nf)
   else
      frame = clamp(frame, 0, self.nf)
   end

   SpriteStrip.draw(self, x, y, frame, sx, sy, r, a)
end
