CustomFont = class()

function CustomFont:__init(texture, chars)
   self.texture = Texture(texture)
   self.chars = chars or {}
end

function CustomFont:measure(text)
   local w,h = 0,0
   if type(text) == 'string' then
      for i = 1,#text do
         local c = self.chars[text:byte(i)]
         if c then
            w = w + c[3]
            if c[4] > h then
               h = c[4]
            end
         end
      end
      return w,h
   end
end

function CustomFont:print(x, y, color, text)
   local verts = {}

   self.texture:activate()

   for i = 1,#text do
      local c = self.chars[text:byte(i)]
      if c then -- font contains this character?
         local cx, cy, cw, ch = unpack(c)
         self.texture:draw(x, y, cw, ch, cx, cy, cw, ch, color)
         --verts[#verts+1] = { cx,    cy,    color, x,    y,    0 }
         --verts[#verts+1] = { cx+cw, cy+ch, color, x+cw, y+ch, 0 }
         x = x + cw
      end
   end

   --local tmode = pge.texture.setmode(PGE_TEX_MODE_MODULATE)
   --pge.gfx.drawcustom(PGE_PRIM_SPRITES, PGE_VERT_TCV, verts)
   --pge.texture.setmode(tmode)
   return x
end
