Dialog = class()

function Dialog:__init(dlgInit, dlgUpdate, dlgBusy)
   self.dlgInit = dlgInit
   self.dlgUpdate = dlgUpdate
   self.dlgBusy = dlgBusy
   self.dlgRslt = {}
end

function Dialog:__call(...)
   self.running = self.dlgInit(...)
   return self
end

function Dialog:update()
   if self.running then
      self.dlgRslt = {self.dlgUpdate()}
      self.running = (self.dlgRslt[1] == self.dlgBusy)
      return self.running
   end
end

function Dialog:result()
   return unpack(self.dlgRslt)
end

Dialog.OSK = pge.utils.osk --Dialog(pge.utils.osk, pge.utils.update, false)
Dialog.Message = pge.utils.msg --Dialog(pge.utils.message, pge.utils.update, PGE_UTILS_DIALOG_RUNNING)
Dialog.Network = pge.utils.net --Dialog(pge.utils.net, pge.utils.update, PGE_UTILS_DIALOG_RUNNING)
Dialog.Browser = Dialog(pge.utils.browser, pge.utils.update, PGE_UTILS_DIALOG_RUNNING)
Dialog.DataSave = Dialog(pge.utils.save, pge.utils.update, PGE_UTILS_DIALOG_RUNNING)
Dialog.DataLoad = Dialog(pge.utils.load, pge.utils.update, PGE_UTILS_DIALOG_RUNNING)
Dialog.AutoSave = Dialog(pge.utils.autosave, pge.utils.update, PGE_UTILS_DIALOG_RUNNING)
Dialog.AutoLoad = Dialog(pge.utils.autoload, pge.utils.update, PGE_UTILS_DIALOG_RUNNING)
