Frame = class(Sprite)

function Frame:__init(texture, ml, mr, mt, mb, x, y, w, h, cx, cy)
   Sprite.__init(self, texture, x, y, w, h, cx, cy)

   self.ml = ml or 0
   self.mr = mr or 0
   self.mt = mt or 0
   self.mb = mb or 0

   self.wc = self.w - self.ml - self.mr
   self.hc = self.h - self.mt - self.mb
   self.xc = self.x + self.ml
   self.xr = self.x + self.w - self.mr
   self.yc = self.y + self.mt
   self.yb = self.y + self.h - self.mb
end

function Frame:draw(x, y, w, h, alpha)
   w = w or self.w
   h = h or self.h
   alpha = alpha or 255

   local ml, mr, mt, mb = self.ml, self.mr, self.mt, self.mb
   local t = self.texture

   local wc, hc = w - ml - mr, h - mt - mb
   local xc, xr = x + ml, x + w - mr
   local yc, yb = y + mt, y + h - mb

   if mt > 0 then
      if ml > 0 then
         -- draw top-left corner
         t:draw(x, y, ml, mt, self.x, self.y, ml, mt, 0, alpha)
      end
      -- draw top side
      t:draw(xc, y, wc, mt, self.xc, self.y, self.wc, mt, 0, alpha)
      if mr > 0 then
         -- draw top-right corner
         t:draw(xr, y, mr, mt, self.xr, self.y, mr, mt, 0, alpha)
      end
   end
   if ml > 0 then
      -- draw left side
      t:draw(x, yc, ml, hc, self.x, self.yc, ml, self.hc, 0, alpha)
   end
   -- draw center
   t:draw(xc, yc, wc, hc, self.xc, self.yc, self.wc, self.hc, 0, alpha)
   if mr > 0 then
      -- draw right side
      t:draw(xr, yc, mr, hc, self.xr, self.yc, mr, self.hc, 0, alpha)
   end
   if mb > 0 then
      if ml > 0 then
         -- draw bottom-left corner
         t:draw(x, yb, ml, mb, self.x, self.yb, ml, mb, 0, alpha)
      end
      -- draw bottom side
      t:draw(xc, yb, wc, mb, self.xc, self.yb, self.wc, mb, 0, alpha)
      if mr > 0 then
         -- draw bottom-right corner
         t:draw(xr, yb, mr, mb, self.xr, self.yb, mr, mb, 0, alpha)
      end
   end
end
