Game = class()

function Game:__init()
   self.timer = pge.timer.create()
   self.fps = 0
   self.nf = 0
   self.nt = 0
end

function Game:exit()
   self.running = false
end

function Game:isRunning()
   return pge.running() and self.running
end

function Game:run()
   self.running = true
   self:starting()
   while self:isRunning() do
      self.timer:update()
      local delta = self.timer:getdelta()
      pge.controls.update()
      self:update(delta)
      pge.gfx.startdrawing()
      self:render()
      pge.gfx.enddrawing()
      pge.gfx.swapbuffers()

      self.nt = self.nt + delta
      self.nf = self.nf + 1
      if self.nt >= 1 then
         self.fps = self.nf / self.nt
         self.nf = 0
         self.nt = 0
         self:updateFps(self.fps)
      end
   end
   self:stopping()
end

function Game:dialog(dlg)
   while self:isRunning() do
      pge.gfx.startdrawing()
      self:render()
      pge.gfx.enddrawing()
      local busy = dlg:update()
      pge.gfx.swapbuffers()
      if not busy then
         return dlg:result()
      end
   end
end

function Game:starting() end
function Game:stopping() end
function Game:update(delta) end
function Game:render() end
function Game:updateFps(fps) end
