SpriteStrip = class(Sprite)

function SpriteStrip:__init(texture, fw, fh, x, y, w, h, cx, cy)
   Sprite.__init(self, texture, x, y, w, h, cx, cy)
   self.fw = fw or self.w                 -- frame width (pixels)
   self.fh = fh or self.h                 -- frame height (pixels)
   self.nfw = floor(self.w / self.fw)     -- grid width (frames)
   self.nfh = floor(self.h / self.fh)     -- grid height (frames)
end

function SpriteStrip:draw(x, y, f, sx, sy, r, a)
   local w = self.fw * (sx or 1)
   local h = self.fh * (sy or 1)

   local tx = floor(f % self.nfw)
   local ty = floor(f / self.nfw)

   self.texture:draw(
      x - self.cx * w, y - self.cy * h, w, h,
      self.x + self.fw * tx, self.y + self.fh * ty, self.fw, self.fh,
      r or self.angle or 0, a or self.alpha or 255)
end
