--------------------------------------------------------------------------------
-- Simple 'class' implementation, partially based on CLASSLIB.LUA

local clsmt = {}
function clsmt:__index(key)
   local base = rawget(self, '__base')
   return base and base[key]
end
function clsmt:__call(...)
   local obj = {}
   setmetatable(obj, self)
   if obj.__init then obj:__init(...) end
   return obj
end

function class(base)
   local cls = { __base = base }
   cls.__type = 'object'
   cls.__base = base
   cls.__class = cls
   cls.__index = cls
   return setmetatable(cls, clsmt)
end

function typeof(value)
   local t = type(value)
   return t == 'table' and value.__type or t
end
local luaClasses = {
   table = table,
   string = string,
   thread = coroutine,
}
function classof(value)
   local t = type(value)
   return t == 'table' and value.__class or luaClasses[t]
end
function instanceof(v,c)
   while c do
      if classof(v) == c then return true end
      c = c.__base
   end
end
