--------------------------------------------------------------------------------
-- Lua tostring extension

do
   local __tostring = tostring

   function tostring(o)
      if type(o) == 'table' then
         local rv = {}
         for k,v in pairs(o) do
            rv[#rv+1] = tostring(k,state) .. '=' .. tostring(v,state)
         end
         return table.concat(rv, ',')
      else
         return __tostring(o)
      end
   end
end
