-- Thanks to doub on #Lua @ freenode.net

local _keywords = {
   ['and'] = true,
   ['break'] = true,
   ['do'] = true,
   ['else'] = true,
   ['elseif'] = true,
   ['end'] = true,
   ['false'] = true,
   ['for'] = true,
   ['function'] = true,
   ['if'] = true,
   ['in'] = true,
   ['local'] = true,
   ['nil'] = true,
   ['not'] = true,
   ['or'] = true,
   ['repeat'] = true,
   ['return'] = true,
   ['then'] = true,
   ['true'] = true,
   ['until'] = true,
   ['while'] = true,
}

local _dumpfuncs
_dumpfuncs = {
   ['table'] = function (tbl, r)
      r[#r+1] = '{'
      for k, v in pairs(tbl) do
         local key = _dumpfuncs[type(k)]
         local val = _dumpfuncs[type(v)]

         if key and val then
            --if type(k) == 'string' and k:find('^[_%a][_%w]*$') and not _keywords[k] then
            --   r[#r+1] = k
            --else
               r[#r+1] = '['
               key(k, r)
               r[#r+1] = ']='
            --end
            --r[#r+1] = '='
            val(v, r)
            r[#r+1] = ','
         end
      end
      r[#r+1] = '}'
   end,
   ['string'] = function (str, r)
      r[#r+1] = ('%q'):format(str)
   end,
   ['number'] = function (num, r)
      r[#r+1] = tostring(num)
   end,
   ['boolean'] = function (bool, r)
      r[#r+1] = tostring(bool)
   end,
   ['function'] = function (func, r)
      r[#r+1] = ('loadstring(%q)'):format(string.dump(func))
   end,
}

-- returns a string that can be read with loadstring
function dump(var)
   local r = {}
   _dumpfuncs[type(var)](var, r)
   return table.concat(r)
end

