local saved

local error_message

local function error_handler(msg)
    error_message = debug.traceback(msg, 2)
end

local function save()
    screen:push_view(ClosingView())
    screen:doFrame()

    db.story:save()
    db.author:save()
    db.feed:save()

    saved = true

    screen:pop_view()
    screen:doFrame()
end

local function main()
    pge.net.init()

    screen:push_view(MainMenuView())
    screen:run()

    ap_disconnect()

    save()
end

local ok = xpcall(main, error_handler)

pge.net.shutdown()

if not ok then
    local tries = 0

    while not saved and tries < 3 do
        pcall(save)
        tries = tries + 1
    end

    while screen:pop_view() do end

    screen:push_view(ErrorView(error_message, saved))
    screen:run()
end
