--------------------------------------------------------------------------------

local max = math.max

View = class(Widget)

function View:__init(title, buttons, ctrltype, ...)
   Widget.__init(self, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT)
   local th, sh = max(16, fontb:height() + 1), max(16, font:height() + 1)
   self.title = TitleBar(0, 0, self.w, th, title)
   self.status = StatusBar(0, self.h - sh, self.w, sh, buttons)
   self.control = (ctrltype or Widget)(0, th, self.w, self.status.y - th, ...)
end

function View:interact()
   self.control:interact()
end

function View:update(delta)
   Widget.update(self, delta)

   self.title.w = self.w
   self.status.w = self.w
   self.status.y = self.h - self.status.h
   self.control.w = self.w
   self.control.h = self.status.y - self.title.h

   self.title:update(delta)
   self.status:update(delta)
   self.control:update(delta)

   if not pge.running() then self:close() end
end

function View:draw()
   self.control:draw()
   self.title:draw()
   self.status:draw()
end

function View:close()
   screen:pop_view()
end

function View:on_close()
end
