--------------------------------------------------------------------------------

CustomThemeView = class(View)

function CustomThemeView:__init(index)
   self.oldtheme = getTheme()
   setTheme(index)
   self.backup = table.copy(theme())

   View.__init(self, ('Edit Theme - "%s"'):format(self.backup.name), {
      [PGE_CTRL_CANCEL] = "Return",
      [PGE_CTRL_ACCEPT] = "Accept",
      [PGE_CTRL_LTRIGGER+
       PGE_CTRL_RTRIGGER] = "Change" },
      ListBox)

   self.colors = { 'name', 'forecolor', 'backcolor', 'infofore', 'infoback',
                   'highlight', 'hottext' }

   table.insert(self.control.items, "Name: " .. theme().name)
   table.insert(self.control.items, "Foreground")
   table.insert(self.control.items, "Background")
   table.insert(self.control.items, "Infobar foreground")
   table.insert(self.control.items, "Infobar background")
   table.insert(self.control.items, "Highlight")
   table.insert(self.control.items, "@@Hot Text")
end

function CustomThemeView:update(delta)
   self.control.items[1] = "Name: " .. theme().name

   View.update(self, delta)
end

function CustomThemeView:close()
   setTheme(self.oldtheme)
   View.close(self)
end

function CustomThemeView:interact()
   View.interact(self)

   local sel = self.colors[self.control.selected]
   if pge.controls.pressed(PGE_CTRL_ACCEPT) then
      self:close()
   elseif pge.controls.pressed(PGE_CTRL_LTRIGGER) then
      if sel == 'name' then
         local ok, name = screen:showDialog(Dialog.OSK("Theme Name", theme().name))
         if name ~= "" then theme().name = name end
      else
         theme()[sel] = (theme()[sel] - 1) % 16
      end
      screen:refresh()
   elseif pge.controls.pressed(PGE_CTRL_RTRIGGER) then
      if sel == 'name' then
         local ok, name = screen:showDialog(Dialog.OSK("Theme Name", theme().name))
         if name ~= "" then theme().name = name end
      else
         theme()[sel] = (theme()[sel] + 1) % 16
      end
      screen:refresh()
   elseif pge.controls.pressed(PGE_CTRL_CANCEL) then
      table.copy(self.backup, theme())
      self:close()
   end
end

