--------------------------------------------------------------------------------

DownloadView = class(View)

function DownloadView:__init(entry)
   self.sid = FFN.storyid(entry.link.alternate)
   self.story = db.story[self.sid]

   shelve_story(self.sid)

   View.__init(self, ('Downloading "%s"...'):format(self.story.title), {
      [PGE_CTRL_CANCEL] = 'Cancel', diskfree=true },
      ProgressBar, 0, self.story.nchapters)

   self.control.show_fraction = true

   self.count = 0
   self.chapter = 0
   offline = false
end

function DownloadView:interact()
   View.interact(self)

   if pge.controls.pressed(PGE_CTRL_CANCEL) then
      self:close()
   end
end

function DownloadView:update(delta, dialog)
   if not dialog then
      if self.chapter > 0 then
         if self.chapter <= self.story.nchapters then
            local filename, url = FFN.chapter(self.sid, self.chapter)
            --~ if needfile(filename) then
               --~ printf('Downloading chapter %d...', self.chapter)
               getchapter(filename, url)
               --~ self.count = self.count + 1
            --~ end
         else
            print('Done.')
            self:close()
         end
      end

      self.control.val = self.chapter
      self.chapter = self.chapter + 1

      screen:refresh()
   end

   View.update(self, delta)
end
