--------------------------------------------------------------------------------

EntryView = class(View)

function EntryView:__init(entry)
   self.entry = entry
   View.__init(self,
      ('"%s" by %s'):format(self.entry.title, self.entry.author.name), {
         [PGE_CTRL_CANCEL] = "Return",
         [PGE_CTRL_ACCEPT] = "Download",
         [PGE_CTRL_TRIANGLE] = "More by this author" },
      TextBox, convert_html(entry.summary, format_tags))

   self.sid = FFN.storyid(entry.link.alternate)

   local userid = FFN.userid(entry.author.uri)
   local nchapters = FFN.nchapters(entry.summary)

   addinfo(self.sid, entry.title, nchapters, userid, entry.author.name)
end

function EntryView:interact()
   View.interact(self)

   if pge.controls.pressed(PGE_CTRL_ACCEPT) then
      local view = DownloadView(self.entry)
      screen:push_view(view)
      if view.count > 0 then
         screen:showDialog(Dialog.Message(('Downloaded %d new chapter(s).'):format(view.count)))
      end
   elseif pge.controls.pressed(PGE_CTRL_TRIANGLE) then
      local userid = FFN.userid(self.entry.author.uri)
      offline = false
      screen:push_view(FeedView(getfeed(FFN.author(userid))))
   elseif pge.controls.pressed(PGE_CTRL_CANCEL) then
      self:close()
   end
end

