--------------------------------------------------------------------------------

ErrorView = class(View)

function ErrorView:__init(message, saved)
    View.__init(self, "Error", { [PGE_CTRL_CANCEL] = "Exit", }, TextBox)

    message = message or '???'

    local f = pge.file.open('error.txt', 'at')
    if f then
        f:write(os.date('%Y-%m-%d %H:%M:%S')..'\n')
        f:write(message..'\n')
        f:write(('-'):rep(60)..'\n\n')
        f:close()
    end

    message = message:gsub('\t', '    ')

    local msg2 = "An unexpected error occurred. Your data " ..
        (saved and 'has been ' or 'could not be ') .. "saved. "

    if f then
        msg2 = msg2 ..
            "The error message and debug information below has been saved to 'error.txt'. " ..
            "If possible, please send this file to the author so the error can be resolved."
    end

    message = msg2 .. '\n\n' .. message

    self.control:settext(message)

    screen:dim(false)
end

function ErrorView:interact()
    View.interact(self)

    if pge.controls.pressed(PGE_CTRL_CANCEL) then
        self:close()
    end
end

