--------------------------------------------------------------------------------

FeedView = class(View)

function FeedView:__init(feed)
   self.feed = feed
   View.__init(self, self.feed.title and self.feed.title or "Feed not available", {
      [PGE_CTRL_CANCEL] = "Return",
      [PGE_CTRL_ACCEPT] = "Read",
      [PGE_CTRL_TRIANGLE] = "Details",
      [PGE_CTRL_SQUARE] = "Update feed" },
      ListBox)

    self:setItems()
end

--[[
function FeedView:update(delta)
   for i, sid in subset(
      self.stories, self.control.first_line, self.control.max_lines)
   do
      local story = db.story[sid]
      self.control.items[i] = '%d. "%s" by %s' % {
         i, story.title, db.author[story.author].name
         }
   end

   View.update(self, delta)
end
--]]

function FeedView:setItems()
   self.stories = {}
   self.control.items = {}

   if self.feed.entry then
      for i, entry in ipairs(self.feed.entry) do
         local sid = FFN.storyid(entry.link.alternate)
         self.stories[i] = sid

         print(sid, db.story[sid])

         self.control.items[i] =
            ((db.story[sid] and db.story[sid].new) and '@@"%s" by %s' or '"%s" by %s'):
            format(entry.title or '?', entry.author and entry.author.name or '?')
      end
   end

   self.control.numbered = true
end

function FeedView:interact()
   View.interact(self)

   if pge.controls.pressed(PGE_CTRL_ACCEPT) then
      if self.stories[self.control.selected] then
         screen:push_view(StoryView(self.stories[self.control.selected]))
      end
   elseif pge.controls.pressed(PGE_CTRL_TRIANGLE) then
      if self.feed.entry[self.control.selected] then
         screen:push_view(EntryView(self.feed.entry[self.control.selected]))
      end
   elseif pge.controls.pressed(PGE_CTRL_SQUARE) then
      screen:dim(true)
      self.feed:load(true)
      self:setItems()
      screen:dim(false)
   elseif pge.controls.pressed(PGE_CTRL_CANCEL) then
      self:close()
   end
end
