--------------------------------------------------------------------------------

function sort_feeds(f1, f2)
   if dirname(f1):lower() < dirname(f2):lower() then
      return true
   end
   return (db.feed[f1].title or "") < (db.feed[f2].title or "")
end

FeedsView = class(View)

function FeedsView:__init(feed)
   View.__init(self, "Feeds", {
      [PGE_CTRL_CANCEL] = "Return",
      [PGE_CTRL_ACCEPT] = "View feed",
      [PGE_CTRL_TRIANGLE] = "Remove", },
      ListBox)

   self.feeds = {}
   for file, feed in pairs(db.feed) do
      table.insert(self.feeds, file)
   end
   --table.sort(self.feeds, sort_feeds)
   table.sort(self.feeds)

   for i, file in ipairs(self.feeds) do
      self.control.items[i] = db.feed[file].title or file
   end

   --~ self.control.numbered = true
end

function FeedsView:interact()
   View.interact(self)

   if pge.controls.pressed(PGE_CTRL_ACCEPT) then

      if self.feeds[self.control.selected] then
         local file = self.feeds[self.control.selected]
         screen:push_view(FeedView(getfeed(file, db.feed[file].url)))
      end

   elseif pge.controls.pressed(PGE_CTRL_CANCEL) then

      self:close()

   elseif pge.controls.pressed(PGE_CTRL_TRIANGLE) then

      if db.feed[self.feeds[self.control.selected]] then

         local rslt = screen:showDialog(Dialog.Message(
            "Remove this feed?", false))

         print(rslt)

         if rslt == true then
            table.remove(self.control.items, self.control.selected)
            db.feed[self.feeds[self.control.selected]] = nil
            table.remove(self.feeds, self.control.selected)
            print(#db.library)
            db.feed:save()
         end

      end

   end
end


