--------------------------------------------------------------------------------

StoryView = class(View)

function StoryView:__init(sid)
    print('StoryView', sid)
   self.sid = sid
   self.story = db.story[self.sid]
   self.story.new = nil
   self.bookmark = db.bookmark:get(self.sid, {})

   shelve_story(self.sid)

   View.__init(self, self.story.title,
      { [PGE_CTRL_CANCEL] = "Return",
        [PGE_CTRL_LTRIGGER] = "Prev Chapter",
        [PGE_CTRL_RTRIGGER] = "Next Chapter",
        [PGE_CTRL_SQUARE+PGE_CTRL_UP] = "Home",
        [PGE_CTRL_SQUARE+PGE_CTRL_DOWN] = "End" },
      TextBox)

   self:loadchapter(self.bookmark.chapter)
end

function StoryView:loadchapter(chapter)
   --pge.system.cpu(222)
   self.bookmark.chapter = clamp(chapter or self.bookmark.chapter or 1, 1, self.story.nchapters or 1)
   self.title.text = ('%s - Chapter %d/%d'):format(self.story.title, self.bookmark.chapter, self.story.nchapters or 1)
   offline = false
   local str = getchapter(FFN.chapter(self.sid, self.bookmark.chapter)) or 'Chapter not available.'
   self.control:settext(convert_html(str, format_tags))
   self.control.position = self.bookmark[self.bookmark.chapter] or 1
   --pge.system.cpu(50)
end

function StoryView:interact()
    View.interact(self)

    if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
        if self.bookmark.chapter > 1 then
            self:loadchapter(self.bookmark.chapter - 1)
        end
    elseif pge.controls.pressed(PGE_CTRL_RTRIGGER) then
        if self.bookmark.chapter < self.story.nchapters then
            self:loadchapter(self.bookmark.chapter + 1)
        end
    elseif pge.controls.held(PGE_CTRL_SQUARE) then
        if pge.controls.pressed(PGE_CTRL_UP) then
            self.control.position = 1
        elseif pge.controls.pressed(PGE_CTRL_DOWN) then
            self.control.position = #self.control.lines
        end
    elseif pge.controls.pressed(PGE_CTRL_CANCEL) then
        self:close()
    end

    self.bookmark[self.bookmark.chapter] = self.control.first_line
end

function StoryView:on_close()
   --pge.system.cpu(222)
   db.bookmark:save()
end
